﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Microsoft.Win32;


namespace moUSBkiller
{
    public partial class Form1 : Form
    {
        private System.Collections.Hashtable config = new System.Collections.Hashtable();
        private System.IO.Ports.SerialPort serial1;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            RegistryKey rConfig = Registry.LocalMachine.CreateSubKey("SOFTWARE\\MoUSBkiller\\Config");

            if (rConfig != null)
            {
                foreach (string key in rConfig.GetValueNames())
                {
                    config[key] = rConfig.GetValue(key);
                }
            }

            rConfig.Close();

            if (config["com1"] != null)
            {
                com1.Text = config["com1"].ToString();

                try
                {
                    serial1 = new System.IO.Ports.SerialPort(config["com1"].ToString(), 9600, System.IO.Ports.Parity.None, 8);
                    serial1.Open();
                    serial1.ReadTimeout = 500;
                }
                catch
                {
                    MessageBox.Show("Проблема с инициализацией порта: " + serial1.PortName);
                    //Dispose();
                }
            }
            status1.BackColor = getStatus(serial1);
            if (config["name1"] != null)
            {
                name1.Text = config["name1"].ToString();
            }
        }

        private System.Drawing.Color getStatus(System.IO.Ports.SerialPort serial)
        {
            if (serial.IsOpen)
            {
                try
                {
                    byte[] b = new byte[] { (byte)'g' };
                    serial.Write(b, 0, 1);

                    int status = serial.Read(b, 0, 1);
                    return (b[0] == 1) ? System.Drawing.Color.Green : System.Drawing.Color.Red;
                }
                catch
                {
                    MessageBox.Show("Проблема с получением статуса размыкателя, порт: " + serial.PortName);
                    return System.Drawing.Color.Black;
                }
            }
            else
            {
                return System.Drawing.Color.Black;
            }
        }
        private void setStatus(bool status, int port)
        {
            System.IO.Ports.SerialPort serial;
            switch (port)
            {
                case 1:
                default:
                    serial = serial1;
                    break;
            }

            if (serial.IsOpen)
            {
                try
                {
                    byte[] b = new byte[] { (byte) ((status)?'1':'0') };
                    serial.Write(b, 0, 1);
                }
                catch
                {
                    MessageBox.Show("Проблема с установкой статуса размыкателя, порт: " + serial.PortName);
                }
            }
            switch (port)
            {
                case 1:
                default:
                    status1.BackColor = getStatus(serial);
                    break;
            }
        }

        private void buttonOn1_Click(object sender, EventArgs e)
        {
            setStatus(true, 1);
        }

        private void buttonOff1_Click(object sender, EventArgs e)
        {
            setStatus(false, 1);
        }

        private void buttonSwitch1_Click(object sender, EventArgs e)
        {
            setStatus(false, 1);
            timer1.Enabled = true;
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            setStatus(true, 1);
        }

        private void name1_TextChanged(object sender, EventArgs e)
        {
            RegistryKey rConfig = Registry.LocalMachine.CreateSubKey("SOFTWARE\\MoUSBkiller\\Config");
            if (rConfig != null)
            {
                rConfig.SetValue("name1", name1.Text);
            }
        }

        private void com1_SelectedIndexChanged(object sender, EventArgs e)
        {
            RegistryKey rConfig = Registry.LocalMachine.CreateSubKey("SOFTWARE\\MoUSBkiller\\Config");
            if (rConfig != null)
            {
                rConfig.SetValue("com1", com1.Text);
            }
        }
    }
}
